// JavaScript Document

// イメージギャラリースクリプト ver 1.0.0


// イメージギャラリーのIDが存在するかチェック



// イメージを格納するボックス生成部分
function imageGallery() {
	if (!document.getElementsByClassName("gallery")) {
		return false;
	}
	
	var gallery = document.getElementsByClassName("gallery");
	
	for(var i = 0; i < gallery.length; i++) {
		if (!gallery[i].getElementsByTagName("a")) {
			return false;
		}
		var imgList = gallery[i].getElementsByTagName("a");
		
		for(var j = 0; j < imgList.length; j++) {
			imgList[j].onclick = function() { // オンクリックイベントハンドラ

				if (this.getElementsByTagName("img")[0].nodeName != "IMG") {
					location.href= this.getAttribute("href");
					return false;
				} 
				
				else if (
					this.getAttribute("href").lastIndexOf(".png") == "-1" &&
					this.getAttribute("href").lastIndexOf(".jpg") == "-1" &&
					this.getAttribute("href").lastIndexOf(".gif") == "-1" &&
					this.getAttribute("href").lastIndexOf(".svg") == "-1"
				) {
					location.href= this.getAttribute("href");
					return false;
				}
				
				showImage(this);
				return false;
			}
		}
	}
}

// イメージを実際に切り替えるファンクション
function showImage(palam) {
	var gallery01 = document.getElementsByClassName("gallery");
	var bgObj = document.createElement("div"); // バックグラウンド用divの生成
	var divObj = document.createElement("div"); // イメージを入れる箱を生成
	var pObj = document.createElement("p"); // 文章とimgタグを入れる段落を生成
	var imgObj = document.createElement("img"); // imgタグを生成
	var spanObj = document.createElement("span"); // spanタグを生成
	var text = document.createTextNode("✖");　// 「閉じる」テキストを生成
	var html = document.getElementsByTagName("html")[0];

	var palamURI = palam.getAttribute("href");
	imgObj.setAttribute("src", palamURI);
	imgObj.setAttribute("title", "元画像を開く"); // 画像を閉じるなら「閉じる」、元画像を開くなら「元画像を開く」
	pObj.appendChild(imgObj);
	divObj.appendChild(pObj);
	spanObj.appendChild(text);
	pObj.appendChild(spanObj);
	
	for(var k = 0; k < gallery01.length; k++) {
		gallery01[k].parentNode.appendChild(divObj);
		gallery01[k].parentNode.appendChild(bgObj);
	}


	// スタイルシート
	var htmlWidth = html.clientWidth; // htmlタグの幅
	var htmlHeight = html.clientHeight;　// htmlタグの高さ
	var imgWidth = imgObj.clientWidth;
	var imgHeight = imgObj.clientHeight;

	bgObj.style.position = "fixed";
	bgObj.style.left = "0px"; // divタグの横位置
	bgObj.style.right = "0px";
	bgObj.style.top = "0px"; // divタグの縦位置
	bgObj.style.bottom = "0px";
	bgObj.style.zIndex = "19999";
	bgObj.style.width = "100%";
	bgObj.style.maxWidth = "100%";
	bgObj.style.height = "100%";
	bgObj.style.filter = "alpha(opacity=50)";
	bgObj.style.opacity = "0.5";
	bgObj.style.backgroundColor = "#000000";
	bgObj.style.backdropFilter = "blur(5px)";
	bgObj.style.margin = "0";
	bgObj.style.padding = "0";


	divObj.style.position = "fixed";

	divObj.style.left = "0"; // divタグの横位置
	divObj.style.right = "0";
	divObj.style.top = "100px"; // divタグの縦位置
	divObj.style.bottom = "0";

	divObj.style.margin = "auto";
	divObj.style.padding = "0";
	divObj.style.display = "flex";
	divObj.style.flexWrap = "wrap";
	divObj.style.justifyContent = "center";
	divObj.style.alignItems = "center";
	divObj.style.overflow = "hidden";
	divObj.style.width = "100%";
	divObj.style.height = "100vh";
	divObj.style.textAlign = "center";


	divObj.style.zIndex = "20000";
	divObj.style.margin = "0";
	divObj.style.padding = "0";

	pObj.style.margin = "0";

	imgObj.style.opacity = "0";
	imgObj.removeAttribute("width"); // 幅の固定をリセット
	imgObj.removeAttribute("height"); //　高さの固定をリセット
	imgObj.style.display = "block";
	imgObj.style.maxWidth = "calc(" + htmlWidth + "px - 20px)";
	imgObj.style.maxHeight = "calc(" + htmlHeight + "px - 20px)";
	imgObj.style.backgroundColor = "white";
	imgObj.style.boxShadow = "0 0 5px black";
	imgObj.style.borderRadius = "3px";
	imgObj.onmouseover = imgObj.style.cursor = "pointer"; // イメージにカーソルが乗っているとき

	spanObj.style.color = "white";
	spanObj.style.position = "fixed";
	spanObj.style.right =  "5px";
	spanObj.style.top = "5px";
	spanObj.style.color = "#ffffff";
	spanObj.style.display = "block";
	spanObj.style.zIndex = "10000";
	spanObj.style.backgroundColor = "#cc0000";
	spanObj.style.width = "40px";
	spanObj.style.height = "40px";
	spanObj.style.lineHeight = "40px";
	spanObj.style.borderRadius = "40px";
	spanObj.style.boxShadow = "0px 0px 3px #000000";
	spanObj.onmouseover = spanObj.style.cursor = "pointer"; // 閉じるにカーソルが乗っているとき

	setTimeout(delayStyle, 0);

	function delayStyle() {
		imgObj.style.opacity = "1";
		divObj.style.top = "0";

		imgObj.style.transition = "0.5s";
		pObj.style.transition = "0.5s";
		divObj.style.transition = "0.5s";
		bgObj.style.transition = "0.5s";
	}

	// 閉じるをクリックしたとき
	spanObj.onclick = function() {
		objStyle();
		setTimeout(closeImage, 500);
	}
	
	// イメージをクリックしたとき
	imgObj.onclick = function() {
		// divObj.parentNode.removeChild(divObj);　// 画像を閉じる場合の処理
		// bgObj.parentNode.removeChild(bgObj);
		var imgLocation = imgObj.getAttribute("src"); // 元画像を開く場合の処理
		window.open().location.href = imgLocation;
	}
	
	// 暗転エリアをクリックしたとき
	
	divObj.onclick = function() {
		objStyle();
		setTimeout(closeImage, 500); // 0.5秒後にオブジェクト削除実行
	}

	// フェードアウト

	function objStyle() {
		divObj.style.top = "100px";
		divObj.style.opacity = "0";
		bgObj.style.opacity = "0";
	}

	// オブジェクト削除

	function closeImage() {
		divObj.parentNode.removeChild(divObj);
		bgObj.parentNode.removeChild(bgObj);
	}

	// ウィンドウサイズが変わったとき用
	window.onresize = function(){
		var htmlWidth = html.clientWidth; // htmlタグの幅を再度取得
		var htmlHeight = html.clientHeight; // htmlタグの高さを再度取得
		imgObj.style.maxWidth = "calc(" + htmlWidth + "px - 20px)";
		imgObj.style.maxHeight = "calc(" + htmlHeight + "px - 20px)";
	}
}




// ↓ウィンドウ読み込みイベントハンドラ

if(window.attachEvent) {
	window.attachEvent("onload", imageGallery);
} else if(window.addEventListener) {
	window.addEventListener("load", imageGallery, false);
}